#!/bin/sh

# TEST: Branches: b0,b1=ro,b2=ro
# TEST: open(D) where D is
# TEST:  a directory in b0
# TEST:  nonexistent in b1
# TEST:  a directory in b0

source scaffold

function files {
cat <<FILES
d /n/lower
d /n/lower/b0
d /n/lower/b1
d /n/lower/b2
FILES
}

function beforefiles {
cat <<FILES
d /n/lower/b0/a
d /n/lower/b2/a

f /n/lower/b0/b
f /n/lower/b1/c
f /n/lower/b2/d

f /n/lower/b0/e
f /n/lower/b1/e
f /n/lower/b2/e
FILES
}

function afterfiles {
	beforefiles
}

( files ; beforefiles) | create_hierarchy

mount_union "" /n/lower/b0 /n/lower/b1=ro /n/lower/b2=ro

checktype $MOUNTPOINT/a 'd'
/bin/ls $MOUNTPOINT/a >/dev/null

echo "/n/lower/b0/b" |diff /mnt/unionfs/b -
echo "/n/lower/b1/c" |diff /mnt/unionfs/c -
echo "/n/lower/b2/d" |diff /mnt/unionfs/d -

echo "/n/lower/b0/e" |diff /mnt/unionfs/e -

unmount_union

( files ; afterfiles )  | check_hierarchy /n/lower

echo "OK"
exit 0
